diff --git a/hardware/openzwave/Manager.h b/hardware/openzwave/Manager.h
index 2dbc552f62..8032126488 100644
--- a/hardware/openzwave/Manager.h
+++ b/hardware/openzwave/Manager.h
@@ -2377,6 +2566,118 @@ OPENZWAVE_EXPORT_WARNINGS_ON
 		 */
 		void GetNodeStatistics( uint32 const _homeId, uint8 const _nodeId, Node::NodeData* _data );
 
+		/**
+		 * \brief Get a Human Readable String for the RouteScheme in the Extended TX Status Frame
+		 * \param _data Pointer to the structure Node::NodeData return from GetNodeStatistics
+		 * \return String containing the Route Scheme Used
+		 */
+		static string GetNodeRouteScheme(Node::NodeData *_data);
+
+		/**
+		 * \brief Get Humand Readable String for the RouteSpeed in the Extended TX Status Frame
+		 * \param _data Pointer to the structure Node::NodeData returned from GetNodeStatistics
+		 * \return String containing the Speed
+		 */
+		static string GetNodeRouteSpeed(Node::NodeData *_data);
+
+	/*@}*/
+
+	//-----------------------------------------------------------------------------
+	// MetaData interface
+	//-----------------------------------------------------------------------------
+	/** \name MetaData Interface
+	 *  Commands for retrieving information about Devices.
+	 */
+	/*@{*/
+	public:
+		/**
+		 * \brief Retrieve metadata about a node
+		 * \param _homeId The Home ID of the driver for the node
+		 * \param _nodeId The node number
+		 * \param _metadata the MetadataFields you are requesting.
+		 * \return a string containing the requested metadata
+		 */
+		string const GetMetaData( uint32 const _homeId, uint8 const _nodeId, Node::MetaDataFields _metadata );
+		/**
+		 * \brief Retrieve ChangeLogs about a configuration revision
+		 * \param _homeId The Home ID of the driver for the node
+		 * \param _nodeId The node number
+		 * \param revision the revision you are requesting
+		 * \return a Node::ChangeLogEntry struct with the ChangeLog Details. if the revision paramater is -1, then then revision passed to this function is invalid
+		 */
+		Node::ChangeLogEntry const GetChangeLog( uint32 const _homeId, uint8 const _nodeId, uint32_t revision);
+
+	/*@}*/
+		//-----------------------------------------------------------------------------
+		// Config File Revision interface
+		//-----------------------------------------------------------------------------
+		/** \name Config File Revision Methods
+		 *  These commands deal with checking/updating Config File's from the OZW master repository
+		 */
+		/*@{*/
+		public:
+			/**
+			 * \brief Check the Latest Revision of the Config File for this device
+			 *
+			 * and optionally update the local database with the latest version
+			 * Config Revisions are exposed on the ManufacturerSpecific CC. (both the latest and loaded version)
+			 *
+			 * Outdated Config Revisions are signaled via Notifications
+			 *
+			 * \param _homeId The Home ID of the driver for the node
+			 * \param _nodeId The node number
+			 * \return Success/Failure of submitting the request.
+			 */
+			bool checkLatestConfigFileRevision(uint32 const _homeId, uint8 const _nodeId);
+
+			/**
+			 * \brief Check the Latest Revision of the Manufacturer_Specific.xml file
+			 *
+			 * and optionally update to the latest version.
+			 *
+			 * Outdated Config Revisions are signaled via Notifications
+			 *
+			 * \param _homeId The Home ID of the driver for the node
+			 * \return Success/Failure of submitting the request.
+			 */
+			bool checkLatestMFSRevision(uint32 const _homeId);
+
+			/**
+			 * \brief Download the latest Config File Revision
+			 *
+			 * The Node will be reloaded depending upon the Option "ReloadAfterUpdate"
+			 * Valid Options include:
+			 * * Never - Never Reload a Node after updating the Config File. Manual Reload is Required.
+			 * * Immediate - Reload the Node Immediately after downloading the latest revision
+			 * * Awake - Reload Nodes only when they are awake (Always-On Nodes will reload immediately, Sleeping Nodes will reload
+			 * 			 when they wake up
+			 *
+			 * Errors are signaled via Notifications
+			 *
+			 * \param _homeId The Home ID of the driver for the node
+			 * \param _nodeId The Node ID of the Node to update the Config File for
+			 * \return Success/Failure of submitting the request.
+			 */
+			bool downloadLatestConfigFileRevision(uint32 const _homeId, uint8 const _nodeId);
+
+			/**
+			 * \brief Download the latest Config File Revision
+			 *
+			 * The ManufacturerSpecific File will be updated, and any new Config Files will also be downloaded.
+			 * Existing Config Files will not be checked/updated.
+			 *
+			 * Errors are signaled via Notifications
+			 *
+			 * \param _homeId The Home ID of the driver for the node
+			 * \return Success/Failure of submitting the request.
+			 */
+			bool downloadLatestMFSRevision(uint32 const _homeId);
+
+		/*@}*/
+
+
+
+
 	};
 	/*@}*/
 } // namespace OpenZWave
diff --git a/hardware/openzwave/ManufacturerSpecificDB.h b/hardware/openzwave/ManufacturerSpecificDB.h
new file mode 100644
index 0000000000..58b3ce559c
--- /dev/null
+++ b/hardware/openzwave/ManufacturerSpecificDB.h
@@ -0,0 +1,154 @@
+//-----------------------------------------------------------------------------
+//
+//	ManufacturerSpecificDB.h
+//
+//	Interface for Handling Device Configuration Files.
+//
+//	Copyright (c) 2016 Justin Hammond <justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+
+#ifndef _ManufacturerSpecificDB_H
+#define _ManufacturerSpecificDB_H
+
+#include <string>
+#include <map>
+#include <list>
+
+#include "Node.h"
+#include "platform/Ref.h"
+#include "Defs.h"
+
+namespace OpenZWave
+{
+	class Mutex;
+	class Driver;
+
+
+	class ProductDescriptor : public Ref
+			{
+			public:
+				ProductDescriptor
+				(
+					uint16 _manufacturerId,
+					uint16 _productType,
+					uint16 _productId,
+					string const& _productName,
+					string const& _manufacturerName,
+					string const& _configPath
+				):
+					m_manufacturerId( _manufacturerId ),
+					m_productType( _productType ),
+					m_productId( _productId ),
+					m_productName( _productName ),
+					m_manufacturerName ( _manufacturerName ),
+					m_configPath( _configPath ),
+					m_configrevision( 0 )
+				{
+				}
+				~ProductDescriptor() {
+
+				}
+				int64 GetKey()const
+				{
+					return( GetKey( m_manufacturerId, m_productType, m_productId ) );
+				}
+
+				static int64 GetKey( uint16 _manufacturerId, uint16 _productType, uint16 _productId )
+				{
+					int64 key = (((int64)_manufacturerId)<<32) | (((int64)_productType)<<16) | (int64)_productId;
+					return key;
+				}
+
+				uint16 GetManufacturerId()const{ return m_manufacturerId; }
+				string GetManufacturerName() const {return m_manufacturerName; }
+				uint16 GetProductType()const{ return m_productType; }
+				uint16 GetProductId()const{ return m_productId; }
+				string GetProductName()const{ return m_productName; }
+				string GetConfigPath()const{ return m_configPath; }
+				void SetConfigRevision(uint32 revision) { m_configrevision = revision;}
+				uint32 GetConfigRevision()const{ return m_configrevision; }
+			private:
+				uint16	m_manufacturerId;
+				uint16	m_productType;
+				uint16	m_productId;
+				string	m_productName;
+				string  m_manufacturerName;
+				string	m_configPath;
+				uint32  m_configrevision;
+			};
+
+
+
+
+
+	/** \brief The _ManufacturerSpecificDB class handles the Config File Database
+	 * that we use to configure devices.
+	 */
+	class OPENZWAVE_EXPORT ManufacturerSpecificDB {
+	public:
+		static ManufacturerSpecificDB *Create();
+		static ManufacturerSpecificDB *Get() { return s_instance; }
+		static void Destroy();
+
+		bool LoadProductXML();
+		void UnloadProductXML();
+		uint32 getRevision() { return m_revision;}
+		uint32 getLatestRevision() { return m_latestRevision;};
+		void setLatestRevision(uint32 rev) { m_latestRevision = rev;};
+		void checkConfigFiles(Driver *);
+		void configDownloaded(Driver *, string file, uint8 node, bool success = true);
+		void mfsConfigDownloaded(Driver *, string file, bool success = true);
+		bool isReady();
+		bool updateConfigFile(Driver *, Node *);
+		bool updateMFSConfigFile(Driver *);
+		void checkInitialized();
+
+	private:
+		void LoadConfigFileRevision (ProductDescriptor *product);
+		ManufacturerSpecificDB();
+		~ManufacturerSpecificDB();
+
+
+
+		Mutex*					m_MfsMutex;            /**< Mutex to ensure its accessed by a single thread at a time */
+
+		static ManufacturerSpecificDB *s_instance;
+	public:
+		ProductDescriptor *getProduct(uint16 _manufacturerId, uint16 _productType, uint16 _productId);
+
+private:
+		static map<uint16,string>	s_manufacturerMap;
+		static map<int64,ProductDescriptor*>	s_productMap;
+		static bool					s_bXmlLoaded;
+
+		list<string> m_downloading;
+		uint32 m_revision;
+		uint32 m_latestRevision;
+		bool m_initializing;
+
+	};
+
+
+}
+
+
+#endif
diff --git a/hardware/openzwave/Msg.h b/hardware/openzwave/Msg.h
index a61c9a07cf..06f4203933 100644
--- a/hardware/openzwave/Msg.h
+++ b/hardware/openzwave/Msg.h
@@ -56,6 +56,7 @@ namespace OpenZWave
 		void SetInstance( CommandClass* _cc, uint8 const _instance );	// Used to enable wrapping with MultiInstance/MultiChannel during finalize.
 
 		void Append( uint8 const _data );
+		void AppendArray( const uint8* const _data, const uint8 _length );
 		void Finalize();
 		void UpdateCallbackId();
 
@@ -142,9 +143,7 @@ namespace OpenZWave
 				return m_buffer[6];
 			}
 			return 0;
-
 		}
-
 		bool isEncrypted() {
 			return m_encrypted;
 		}
diff --git a/hardware/openzwave/Node.h b/hardware/openzwave/Node.h
index 163ed113a8..37a900abc7 100644
--- a/hardware/openzwave/Node.h
+++ b/hardware/openzwave/Node.h
@@ -57,6 +57,7 @@ namespace OpenZWave
 	class ValueShort;
 	class ValueString;
 	class Mutex;
+	class ProductDescriptor;
 
 	/** \brief The Node class describes a Z-Wave node object...typically a device on the
 	 *  Z-Wave network.
@@ -83,6 +84,7 @@ namespace OpenZWave
 			friend class Language;
 			friend class Lock;
 			friend class ManufacturerSpecific;
+			friend class ManufacturerSpecificDB;
 			friend class Meter;
 			friend class MeterPulse;
 			friend class MultiInstance;
@@ -397,7 +399,7 @@ namespace OpenZWave
 			 * \return Pointer to the requested CommandClass object if supported, otherwise NULL.
 			 * \see CommandClass, m_commandClassMap
 			 */
-			CommandClass* GetCommandClass( uint8 const _commandClassId )const;
+			CommandClass* GetCommandClass( uint8 const _commandClassId, bool advertised = false )const;
 			void ApplicationCommandHandler( uint8 const* _data, bool encrypted );
 
 			/**
@@ -405,20 +407,37 @@ namespace OpenZWave
 			 * as Secured if they exist, and if they don't, it creates new Command Classes and sets them up as Secured
 			 * @param _data a list of Command Classes that are Secured by the Device
 			 * @param _length the length of the _data string
+			 * @param _instance the instance of the Class thats Secured.
 			 */
-			void SetSecuredClasses( uint8 const* _data, uint8 const _length );
+			void SetSecuredClasses( uint8 const* _data, uint8 const _length, uint32 const _instance = 1);
 			void SetSecured(bool secure);
+			bool IsSecured();
+			/**
+			 * This function sets a Global Instance Label for all CommandClasses that don't define their
+			 * own labels
+			 */
+			void SetInstanceLabel(uint8 const _instance, char *label);
+			/** This function gets a Instance Label for a ValueID. It either users the Global Instance Label
+			 * above, or a Label for a Specific CC
+			 */
+			string GetInstanceLabel(uint8 const _ccid, uint8 const _instance);
+
+			/** Get The Number of Instances on this node
+			 *
+			 */
+			uint8 GetNumInstances(uint8 const _ccid);
 		private:
 			/**
 			 * Creates the specified command class object and adds it to the node (via the
 			 * m_commandClassMap) if it doesn't exist.
 			 * No new object is created if it already exists for this node.
 			 * \param _commandClassId Class ID (a single byte value) identifying the command class requested.
+			 * \param advertised if the CommandClass is Advertised by this node
 			 * \return Pointer to the CommandClass object just added to the map (NULL if the object
 			 * was already there or if the CommandClass object creation failed).
 			 * \see CommandClass, CommandClasses::CreateCommandClass, m_commandClassMap
 			 */
-			CommandClass* AddCommandClass( uint8 const _commandClassId );
+			CommandClass* AddCommandClass( uint8 const _commandClassId, bool advertised = false);
 			/**
 			 * Removes a command class object from the node (via the m_commandClassMap).  Before removing the
 			 * object, this function also removes any values stored in the object's ValueStore.
@@ -432,7 +451,63 @@ namespace OpenZWave
 			void WriteXML( TiXmlElement* _nodeElement );
 
 			map<uint8,CommandClass*>		m_commandClassMap;	/**< Map of command class ids and pointers to associated command class objects */
+			map<uint8,CommandClass*>		m_advertisedCommandClassMap; /**< Map of Command Class Id's and Pointers to the Class for Advertised CommandClasses */
 			bool							m_secured; /**< Is this Node added Securely */
+			map<uint8, string>				m_globalInstanceLabel; /** < The Global Labels for Instances for CC that dont define their own labels */
+			//-----------------------------------------------------------------------------
+			// Configuration Revision Related Classes
+			//-----------------------------------------------------------------------------
+		public:
+			void SetProductDetails(ProductDescriptor *product);
+			/** Get a path to the config file for this device
+			 *
+			 * @return a path relative to the config directory for the config file. returns a empty string if a config file is not present.
+			 */
+			string getConfigPath();
+			/** Get the latest local revision of the config file for this node
+			 *
+			 * @return a revision number
+			 */
+			uint32 getFileConfigRevision() { return m_fileConfigRevision; };
+			/** Get the Revision number of the config that is laoded for this Node
+			 *
+			 * @return the revision number currently loaded.
+			 */
+			uint32 getLoadedConfigRevision() { return m_loadedConfigRevision; };
+			/** Get the Latest Config File revision available at openzwave.com
+			 *
+			 * @return The latest revision number available
+			 */
+			uint32 getLatestConfigRevision() { return m_latestConfigRevision; };
+			/** Set the revision number of the Config File for this device
+			 *
+			 * @param rev the revision number
+			 */
+			void setFileConfigRevision(uint32 rev);
+			/** Set the revision number of the config that is loaded for this device
+			 *
+			 * @param rev the revision number
+			 */
+			void setLoadedConfigRevision(uint32 rev);
+			/** Set the revision number of the latest available config file for this device
+			 *
+			 * @param rev the revision number
+			 */
+			void setLatestConfigRevision(uint32 rev);
+			/** Check the latest available revision number for this device.
+			 *
+			 */
+			void checkLatestConfigRevision( );
+
+		private:
+
+
+			ProductDescriptor *m_Product;
+
+
+			uint32 m_fileConfigRevision;
+			uint32 m_loadedConfigRevision;
+			uint32 m_latestConfigRevision;
 			//-----------------------------------------------------------------------------
 			// Basic commands (helpers that go through the basic command class)
 			//-----------------------------------------------------------------------------
@@ -450,23 +525,24 @@ namespace OpenZWave
 			// Values (handled by the command classes)
 			//-----------------------------------------------------------------------------
 		public:
-			ValueID CreateValueID( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, ValueID::ValueType const _type );
+			ValueID CreateValueID( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, ValueID::ValueType const _type );
 
 			Value* GetValue( ValueID const& _id );
-			Value* GetValue( uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex );
-			bool RemoveValue( uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex );
+			Value* GetValue( uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex );
+			bool RemoveValue( uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex );
 
 			// Helpers for creating values
-			bool CreateValueBool( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _default, uint8 const _pollIntensity );
-			bool CreateValueButton( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, uint8 const _pollIntensity );
-			bool CreateValueByte( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _default, uint8 const _pollIntensity );
-			bool CreateValueDecimal( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _default, uint8 const _pollIntensity );
-			bool CreateValueInt( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, int32 const _default, uint8 const _pollIntensity );
-			bool CreateValueList( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _size, vector<ValueList::Item> const& _items, int32 const _default, uint8 const _pollIntensity );
-			bool CreateValueRaw( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const* _default, uint8 const _length, uint8 const _pollIntensity );
-			bool CreateValueSchedule( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _pollIntensity );
-			bool CreateValueShort( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, int16 const _default, uint8 const _pollIntensity );
-			bool CreateValueString( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint8 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _default, uint8 const _pollIntensity );
+			bool CreateValueBitSet( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, int32 const _default, uint8 const _pollIntensity );
+			bool CreateValueBool( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, bool const _default, uint8 const _pollIntensity );
+			bool CreateValueButton( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, uint8 const _pollIntensity );
+			bool CreateValueByte( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _default, uint8 const _pollIntensity );
+			bool CreateValueDecimal( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _default, uint8 const _pollIntensity );
+			bool CreateValueInt( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, int32 const _default, uint8 const _pollIntensity );
+			bool CreateValueList( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _size, vector<ValueList::Item> const& _items, int32 const _default, uint8 const _pollIntensity );
+			bool CreateValueRaw( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const* _default, uint8 const _length, uint8 const _pollIntensity );
+			bool CreateValueSchedule( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, uint8 const _pollIntensity );
+			bool CreateValueShort( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, int16 const _default, uint8 const _pollIntensity );
+			bool CreateValueString( ValueID::ValueGenre const _genre, uint8 const _commandClassId, uint8 const _instance, uint16 const _valueIndex, string const& _label, string const& _units, bool const _readOnly, bool const _writeOnly, string const& _default, uint8 const _pollIntensity );
 
 			// helpers for removing values
 			void RemoveValueList( ValueList* _value );
@@ -492,6 +568,11 @@ namespace OpenZWave
 			//-----------------------------------------------------------------------------
 		private:
 			bool RequestDynamicValues();
+		public:
+			//-----------------------------------------------------------------------------
+			// Refresh Dynamic Values from CommandClasses on Wakeup
+			//-----------------------------------------------------------------------------
+			void RefreshValuesOnWakeup();
 			//-----------------------------------------------------------------------------
 			// Groups
 			//-----------------------------------------------------------------------------
@@ -501,6 +582,7 @@ namespace OpenZWave
 			uint32 GetAssociations( uint8 const _groupIdx, uint8** o_associations );
 			uint32 GetAssociations( uint8 const _groupIdx, InstanceAssociation** o_associations );
 			uint8 GetMaxAssociations( uint8 const _groupIdx );
+			bool IsMultiInstance( uint8 const _groupIdx );
 			string GetGroupLabel( uint8 const _groupIdx );
 			void AddAssociation( uint8 const _groupIdx, uint8 const _targetNodeId, uint8 const _instance = 0x00 );
 			void RemoveAssociation( uint8 const _groupIdx, uint8 const _targetNodeId, uint8 const _instance = 0x00 );
@@ -590,26 +672,59 @@ namespace OpenZWave
 					uint8 m_quality;					// Node quality measure
 					uint8 m_lastReceivedMessage[254];
 					list<CommandClassData> m_ccData;
+					bool m_txStatusReportSupported;
+					uint16 m_txTime;
+					uint8 m_hops;
+					char m_rssi_1[8];
+					char m_rssi_2[8];
+					char m_rssi_3[8];
+					char m_rssi_4[8];
+					char m_rssi_5[8];
+					uint8 m_ackChannel;
+					uint8 m_lastTxChannel;
+					TXSTATUS_ROUTING_SCHEME m_routeScheme;
+					char m_routeUsed[9];
+					TXSTATUS_ROUTE_SPEED m_routeSpeed;
+					uint8 m_routeTries;
+					uint8 m_lastFailedLinkFrom;
+					uint8 m_lastFailedLinkTo;
 			};
 
 			private:
 			void GetNodeStatistics( NodeData* _data );
 
-			uint32 m_sentCnt;				// Number of messages sent from this node.
+			uint32 m_sentCnt;					// Number of messages sent from this node.
 			uint32 m_sentFailed;				// Number of sent messages failed
-			uint32 m_retries;				// Number of message retries
+			uint32 m_retries;					// Number of message retries
 			uint32 m_receivedCnt;				// Number of messages received from this node.
 			uint32 m_receivedDups;				// Number of duplicated messages received;
-			uint32 m_receivedUnsolicited;			// Number of messages received unsolicited
+			uint32 m_receivedUnsolicited;		// Number of messages received unsolicited
 			uint32 m_lastRequestRTT;			// Last message request RTT
 			uint32 m_lastResponseRTT;			// Last message response RTT
-			TimeStamp m_sentTS;				// Last message sent time
+			TimeStamp m_sentTS;					// Last message sent time
 			TimeStamp m_receivedTS;				// Last message received time
 			uint32 m_averageRequestRTT;			// Average Request round trip time.
-			uint32 m_averageResponseRTT;			// Average Response round trip time.
-			uint8 m_quality;				// Node quality measure
-			uint8 m_lastReceivedMessage[254];		// Place to hold last received message
-			uint8 m_errors;					// Count errors for dead node detection
+			uint32 m_averageResponseRTT;		// Average Response round trip time.
+			uint8 m_quality;					// Node quality measure
+			uint8 m_lastReceivedMessage[254];	// Place to hold last received message
+			uint8 m_errors;
+			bool m_txStatusReportSupported;		// if Extended Status Reports are available
+			uint16 m_txTime;					// Time Taken to Transmit the last frame
+			uint8 m_hops;						// Hops taken in transmitting last frame
+			char m_rssi_1[8];					// RSSI Level of last transmission
+			char m_rssi_2[8];					// RSSI Level of last transmission
+			char m_rssi_3[8];					// RSSI Level of last transmission
+			char m_rssi_4[8];					// RSSI Level of last transmission
+			char m_rssi_5[8];					// RSSI Level of last transmission
+			uint8 m_ackChannel;					// Channel we received the last ACK on
+			uint8 m_lastTxChannel;				// Channel we transmitted the last frame on
+			TXSTATUS_ROUTING_SCHEME m_routeScheme;				// The Scheme used to route the last frame
+			uint8 m_routeUsed[4];				// The Route Taken in the last frame
+			TXSTATUS_ROUTE_SPEED m_routeSpeed;					// Baud Rate of the last frame
+			uint8 m_routeTries;					// The number of attempts to route the last frame
+			uint8 m_lastFailedLinkFrom;			// The last failed link from
+			uint8 m_lastFailedLinkTo;			// The last failed link to
+
 
 			//-----------------------------------------------------------------------------
 			//	Encryption Related
@@ -622,6 +737,54 @@ namespace OpenZWave
 			private:
 			uint8 m_lastnonce;
 			uint8 m_nonces[8][8];
+
+			//-----------------------------------------------------------------------------
+			//	MetaData Related
+			//-----------------------------------------------------------------------------
+
+			public:
+			/**
+			 * MetaData Fields.
+			 * Available Fields that contain metadata about a device.
+			 * \see Manager::AddWatcher
+			 * \see Manager::BeginControllerCommand
+			 */
+			enum MetaDataFields
+			{
+				MetaData_OzwInfoPage_URL,
+				MetaData_ZWProductPage_URL,
+				MetaData_ProductPic,
+				MetaData_Description,
+				MetaData_ProductManual_URL,
+				MetaData_ProductPage_URL,
+				MetaData_InclusionHelp,
+				MetaData_ExclusionHelp,
+				MetaData_ResetHelp,
+				MetaData_WakeupHelp,
+				MetaData_ProductSupport_URL,
+				MetaData_Frequency,
+				MetaData_Name,
+				MetaData_Identifier,
+				MetaData_Invalid = 255
+			};
+
+			struct ChangeLogEntry {
+				string author;
+				string date;
+				int revision;
+				string description;
+			};
+			string const GetMetaData(MetaDataFields);
+			MetaDataFields const GetMetaDataId(string);
+			string const GetMetaDataString(MetaDataFields);
+			ChangeLogEntry const GetChangeLog(uint32_t);
+
+
+			private:
+			void ReadMetaDataFromXML(TiXmlElement const* _valueElement);
+			void WriteMetaDataXML(TiXmlElement*);
+			map<MetaDataFields, string> m_metadata;
+			map<uint32_t, ChangeLogEntry> m_changeLog;
 	};
 
 
